Lua_ArtifactLineupItem = class("Lua_ArtifactLineupItem", Lua_DisplayObject)
function Lua_ArtifactLineupItem:ctor(p)
	self:superCall("ctor", p, "ArtifactSkillItem_skin")
end

function Lua_ArtifactLineupItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg.clickScale = false
end

function Lua_ArtifactLineupItem:dispose()
	if self.redPoint then
		self.redPoint:dispose()
		self.redPoint = nil
	end
	self.owner = nil
	self.callBack = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_ArtifactLineupItem:setData(index, unlockLv, artifactDic, lineupIdx)
	self.index = index
	self.unlockLv = unlockLv
	self.data = nil

	if unlockLv > DataCenter.roleData.level then
		self.bg:setAltas("hero_embattle", "xui_zd_widget_6")
		self.icon:setEnable(false)
		self.levelBg:setEnable(false)
		self.levelText:setEnable(false)
		self.energyIcon:setEnable(false)
		self.energyText:setEnable(false)
		self.unlockText:setEnable(true)
		self:showRedDot(false)
	else
		local artifactId = artifactDic[lineupIdx][index]
		if artifactId == nil or artifactId == 0 then
			self.bg:setAltas("hero_embattle", "xui_zd_widget_5")
			self.icon:setEnable(false)
			self.levelBg:setEnable(false)
			self.levelText:setEnable(false)
			self.energyIcon:setEnable(false)
			self.energyText:setEnable(false)

			artifactId = DataCenter.heroLineupData:getUnWearArtifact(artifactDic, lineupIdx)
			self:showRedDot(artifactId ~= nil)
		else
			self.data = DataCenter.artifactUtil:getArtifactVoById(artifactId);
			local config = Lua_SkillConfigData.getConfigData(self.data.skill_id);
			if config == nil then
				self.data = nil;
				self.bg:setAltas("hero_embattle", "xui_zd_widget_5")
				self.icon:setEnable(false)
				self.levelBg:setEnable(false)
				self.levelText:setEnable(false)
				self.energyIcon:setEnable(false)
				self.energyText:setEnable(false)
				self:showRedDot(false)
			else
				self.bg:setAltas("hero_embattle", "xui_zd_widget_6")
				self.icon:setEnable(true)
				self.levelBg:setEnable(true)
				self.levelText:setEnable(true)
				self.energyIcon:setEnable(true)
				self.energyText:setEnable(true)

				self.icon:setAltas(config.atlas, config.sprite)
				self.levelText.text = config.level
				self.energyText.text = config.costEnergy
				self:showRedDot(false);
			end
		end
		self.unlockText:setEnable(false)
	end
end

function Lua_ArtifactLineupItem:showRedDot(value)
	if value == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content)
			self.redPoint:setLocation(24, 23, 0)
			self.redPoint:createRedPointEff()
		end
		self.redPoint:updateRedPointShow(true)
	else
		if self.redPoint then
			self.redPoint:updateRedPointShow(false)
		end
	end
end

function Lua_ArtifactLineupItem:setClick(owner, callBack)
	self.owner = owner
	self.callBack = callBack
	if owner == nil or callBack == nil then
		self.bg:removeClickFuntion(self, self.onClick)
	else
		self.bg:addClickFuntion(self, self.onClick)
	end
end

function Lua_ArtifactLineupItem:onClick(go)
	if self.unlockLv > DataCenter.roleData.level then
		OperateAlert.show(LanUtil.formateStr(350043, tostring(self.unlockLv)))
		return
	end
	if self.owner and self.callBack then
		self.callBack(self.owner)
	end
end