Lua_FightLineupConnectItem = class("Lua_FightLineupConnectItem", Lua_DisplayObject)
function Lua_FightLineupConnectItem:ctor(p, showType)
	self.showType = showType or 1
	self:superCall("ctor", p, "FightLineupConnectItem_skin")
end

function Lua_FightLineupConnectItem:buildShowItem()
	self:superCall("buildShowItem")

	self.forceNum = Lua_NumberImage.new(self.content)
	self.forceNum.preStr = "xui_zl1_number_0"
	self.forceNum.numOffsetX = -4

	if self.showType == 2 then
		self.nameText.pivotValue = 5
		self.nameText.alignmentValue = 5
		self.nameText:setLocation(-45, 17, 0)
		self.forceIcon:setLocation(-66, -28, 0)

		self.forceNum:setLocation(-95, -28, 0)
		self.forceNum.pivot = -1
	else
		self.nameText.pivotValue = 3
		self.nameText.alignmentValue = 3
		self.nameText:setLocation(45, 17, 0)
		self.forceIcon:setLocation(66, -28, 0)

		self.forceNum:setLocation(95, -28, 0)
		self.forceNum.pivot = 1
	end

	self.connIcon:addClickFuntion(self, self.onCheckConnect)
end

function Lua_FightLineupConnectItem:dispose()
	if self.connArr then
		local len = self.connArr:getSize()
		local vo
		while (len > 0) do
			vo = self.connArr:remove(len)
			if vo then
				vo:remove()
				vo = nil
			end
			len = len - 1
		end
		self.connArr = nil
	end
	self:superCall("dispose")
end

function Lua_FightLineupConnectItem:setLineup(lineupType, lineupIdx)
	self.lineupType = lineupType
	self.lineupIdx = lineupIdx
	local vo = DataCenter.heroLineupData:getLineupVo(lineupType)
	local num = vo:getConnectActivateNum(lineupIdx)
	self.connIcon:setAltas("hero_embattle", "xui_bz_widget_"..24 + num)
	self.connCount.text = num
end

function Lua_FightLineupConnectItem:setConfig(list, lineupIdx)
	local num, arr = DataCenter.heroLineupData:getConnectArrByConfig(list, lineupIdx)
	self.connIcon:setAltas("hero_embattle", "xui_bz_widget_"..24 + num)
	self.connCount.text = num
	self.connArr = arr
end

function Lua_FightLineupConnectItem:setProto(list)
	local num, arr = DataCenter.heroLineupData:getConnectArrByProto(list)
	self.connIcon:setAltas("hero_embattle", "xui_bz_widget_"..24 + num)
	self.connCount.text = num
	self.connArr = arr
end

function Lua_FightLineupConnectItem:setData(name, force)
	self.nameText.text = name
	if force and force > 0 then
		self.forceIcon:setEnable(true)
		self.forceNum:setEnable(true)
		self.forceNum.num = force
	else
		self.forceIcon:setEnable(false)
		self.forceNum:setEnable(false)
	end
end

function Lua_FightLineupConnectItem:onCheckConnect(go)
	if self.lineupType and self.lineupType then
		local num, arr = DataCenter.heroLineupData:getConnectArrByLineup(self.lineupType, self.lineupIdx)
		if arr == nil or arr:getSize() <= 0 then
			OperateAlert.showLangValue(126066)
			return
		end
		Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, arr)
	else
		if self.connArr == nil or self.connArr:getSize() <= 0 then
			OperateAlert.showLangValue(126066)
			return
		end
		Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, self.connArr)
	end
end