--战斗布阵
checkRequire("Lua_BaseLineupWindow");
checkRequire("Lua_FightLineupConnectItem");
Lua_FightLineupWindow = class("Lua_FightLineupWindow", Lua_BaseLineupWindow)
function Lua_FightLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_FightLineupWindow";
    self.skinName = "FightLineupWindow_skin";
end

function Lua_FightLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.btnFight:addClickFuntion(self, self.onBtnFightClick);
    self.one_btn:setEnable(DataCenter.funcOpenData:isOpened(10266));
    self.one_btn:addClickFuntion(self, self.onOneBtnClick);

    self.attackerConnectItem = Lua_FightLineupConnectItem.new(self.topObject)
    self.attackerConnectItem:setLocation(-312, -41, 0)

    self.defenderConnectItem = Lua_FightLineupConnectItem.new(self.topObject, 2)
    self.defenderConnectItem:setLocation(312, -41, 0)
end

function Lua_FightLineupWindow:dispose()
    if self.attackerConnectItem then
        self.attackerConnectItem:dispose();
        self.attackerConnectItem = nil;
    end
    if self.defenderConnectItem then
        self.defenderConnectItem:dispose();
        self.defenderConnectItem = nil;
    end
    if self.enemyLineupPanel ~= nil then
        self.enemyLineupPanel:dispose();
        self.enemyLineupPanel = nil;
    end
    self:superCall("dispose");
end

function Lua_FightLineupWindow:updateShowInfo(param)
    if type(param) == "table" then
        self.template_id = param.template_id;
        self.stage_id = param.stage_id;
        if param.default_camp ~= nil then
            self.defaultCamp = param.default_camp;
        end
        self.monster_player_id = param.monster_player_id -- 配置表怪物
    elseif type(param) == "number" then
        self.template_id = param;
    end
    self.lineupType = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;
    
    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:updateEnemyInfo();
    self.campSiftPanel:setSelected(self.defaultCamp, 0);
end

-- 己方光环更新
function Lua_FightLineupWindow:updateAureoleInfo()
    local force = DataCenter.heroLineupData:calcLineupForce(self.lineupType, self.lineupIdx);
    self.attackerConnectItem:setData(DataCenter.roleData.name, force);
    self.attackerConnectItem:setLineup(self.lineupType, self.lineupIdx)
end

-- 更新敌方数据
function Lua_FightLineupWindow:updateEnemyInfo()
    if self.monster_player_id == nil then
        return
    end
    local config = Lua_MonsterPlayerConfigData.getConfigData(self.monster_player_id);
    -- local aureole_id = config.camp_aureole_id;
    -- if aureole_id == nil then
    --     aureole_id = 0;
    --     local list = config.fighter_list
    --     if list ~= nil and list[self.lineupIdx] ~= nil then
    --         local hidDic = {};
    --         local dic = list[self.lineupIdx];
    --         for i = 1, #dic do
    --             local config = Lua_MonsterConfigData.getMonsterConfig(dic[i][1]);
    --             if config ~= nil then
    --                 hidDic[config.heroVo.id] = dic[i][2];
    --             end
    --         end
    --         local aureole_list = DataCenter.heroLineupData:getAureoleInfoByHeroTab(hidDic);
    --         aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
    --     end
    -- end
    self.defenderConnectItem:setData(config.name[self.lineupIdx], config.force[self.lineupIdx]);
    self:updateEnemyLineup(1, config.fighter_list);
end

-- 九宫格数据更新
function Lua_FightLineupWindow:updateEnemyLineup(dataType, list)
    if self.enemyLineupPanel == nil then
        self.enemyLineupPanel = Lua_HeroGridViewPanel.new(self.content);
        self.enemyLineupPanel:setRectAnchor(1);
        self.enemyLineupPanel:setLocation(204, -209, 0);
        self.enemyLineupPanel:setCanClick(true);
        self.enemyLineupPanel:setLayout(1, 2);
        self.enemyLineupPanel:setGridCell(75, 75);
    end
    if dataType == 1 then -- 配置表数据
        self.defenderConnectItem:setConfig(list, self.lineupIdx);
        self.enemyLineupPanel:setDataByConfig(list, self.lineupIdx);
    elseif dataType == 2 then -- 服务端数据
        self.defenderConnectItem:setProto(list);
        self.enemyLineupPanel:setDataByProto(list);
    end
end

--一键上阵
function Lua_FightLineupWindow:onOneBtnClick(go)
    DataCenter.heroLineupData:setHeroOneKey(self.standType, self.heroDic, self.lineupIdx, self.lineupType);

    self.data:initLineUpInfo();
    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
end

--开始战斗
function Lua_FightLineupWindow:onBtnFightClick(go)
    if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
        OperateAlert.showLangValue(10031);
        return;
    end
    self.clickTime = getTime();

    local recordId = DataCenter.fightData:getRecordIdByTemplateId(self.template_id);
    if recordId > 0 then
        return;
    end

    if DataCenter.guideData.bPlayGuide then--引导中
        self:onFight();
    else
        self:onCheckArtifact();
    end
end

function Lua_FightLineupWindow:onFight()
    if self:checkIsChange() then
        self:onSaveLineup()
    end
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
end