-- 英雄布阵选择Item
Lua_HeroLineupCell = class("Lua_HeroLineupCell", Lua_ListCell);
function Lua_HeroLineupCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroLineupCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.86, 0.86, 0.86)
end

function Lua_HeroLineupCell:dispose()
    if self.kunXuDispose ~= nil then
        self:kunXuDispose();
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self.lockIcon = nil;
    self.customParam = nil;
    self.curLineupType = nil;
    self.curLineupIdx = nil;
    self.lineupIdx = nil;
    self.standIdx = nil;    
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroLineupCell:setCustomParam(customParam)
    self.customParam = customParam;
    self.curLineupType = Mathf.Floor(customParam / 10000);
    self.curLineupIdx = Mathf.Floor(customParam / 100 % 10);
end

function Lua_HeroLineupCell:setData(data)
    self.data = DataCenter.heroData:getItemByUniqueId(data);
    self.itemIcon:setData(self.data);
    self:updateSelected();
end

function Lua_HeroLineupCell:updateSelected()
    local vo = DataCenter.heroLineupData:getLineupVo(self.curLineupType);
    self.lineupIdx = vo:getHeroLineupIdx(self.data.id)
    self.standIdx = vo:getHeroStandIdx(self.data.unique_id)
    
    if self.lineupIdx == self.curLineupIdx then
        self.itemIcon:setDrawMask(self.standIdx ~= nil)
        self.itemIcon:setMask(false)
        self.itemIcon:showText(0, nil)
    else
        self.itemIcon:setDrawMask(false)
        if self.lineupIdx then
            self.itemIcon:setMask(true)
            if self.standIdx == nil then
                self.itemIcon:showText(0, nil)
            else
                self.itemIcon:showText(0, LanUtil.formateStr(126324, convert_arab_to_chinese(self.lineupIdx)))
            end
        else
            self.itemIcon:setMask(false)
            self.itemIcon:showText(0, nil)
        end
    end
end

function Lua_HeroLineupCell:onPressClick()
    -- 引导上阵后，不能下阵 防点击过快
    local antiRepeatClick = DataCenter.guideCommonData.antiRepeatClick;
    if antiRepeatClick then
        return;
    elseif antiRepeatClick == false then 
        DataCenter.guideCommonData.antiRepeatClick = true;
    end

    local isGuiding = DataCenter.guideData.isGuiding;
    if isGuiding then -- 引导点击间隔
        if self.clickTime ~= nil and getTime() - self.clickTime < 0.6 then
            return;
        end
        self.clickTime = getTime();
    end
    if self.lineupIdx and self.lineupIdx ~= self.curLineupIdx then
        OperateAlert.show(LanUtil.formateStr(126325, convert_arab_to_chinese(self.lineupIdx)))
        return
    end
    Lua_MsgUtil.callFunc("LINEUP_HERO_SELECT", self.data);
end

function Lua_HeroLineupCell:onLongPressClick()
    if not Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") then
        Lua_WindowUtil.openWin("Lua_HeroTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
    end
end