-- 阵法站位
Lua_HeroLineupStandWindow = class("Lua_HeroLineupStandWindow", Lua_Window)
function Lua_HeroLineupStandWindow:ctor()
    self:superCall("ctor")
    
    self.windowName = "Lua_HeroLineupStandWindow"
    self.skinName = "HeroLineupStandWindow_skin"
    self.showBlackMask = true
    self.isClickClose = true
end

function Lua_HeroLineupStandWindow:buildShowItem()
    self:superCall("buildShowItem")

    self.standArr = Array()
    local list = DataCenter.heroLineupUtil.standConfigInfo
    local item
    for i = 1, #list do
        if list[i].is_show == 1 then
            item = Lua_HeroLineupStandItem.new(self.content)
            item:setData(list[i])
            self.standArr:add(item)
        end
    end
    local len = self.standArr:getSize()
    local space = 124
    local w = -(space * len) / 2 + space / 2
    for i = 1, len do
        self.standArr[i]:setLocation(((i - 1) % len) * space + w, 27.5, 0)
    end

    self.subBtn:addClickFuntion(self, self.onSubBtnClick)
    self:addLuaEvent("LINEUP_ON_SELECT_STAND_TYPE", self, self.onStandTypeSelected) -- 选择站位更新布阵
end

function Lua_HeroLineupStandWindow:onStandTypeSelected(standType)
    if self.standType == standType then
        return
    end
    self.standType = standType
    for i = 1, self.standArr:getSize() do
        self.standArr[i]:setSelected(self.standArr[i].data.id == standType)
    end
end

function Lua_HeroLineupStandWindow:onSubBtnClick()
    Lua_MsgUtil.callFunc("LINEUP_STANDTYPE_SELECT", self.standType)
    self:hide()
end

function Lua_HeroLineupStandWindow:dispose()
    if self.standArr then
        self.standArr:dispose()
        self.standArr:clear()
        self.standArr = nil
    end
    self:superCall("dispose")
end

function Lua_HeroLineupStandWindow:showWin(param)
    self:superCall("showWin", param)
    self:onStandTypeSelected(param)
end




















Lua_HeroLineupStandItem = class("Lua_HeroLineupStandItem", Lua_DisplayObject)
function Lua_HeroLineupStandItem:ctor(p)
    self:superCall("ctor", p, "HeroLineupStandItem_skin")
end

function Lua_HeroLineupStandItem:buildShowItem()
	self:superCall("buildShowItem")

    self.bg:addClickFuntion(self, self.onIconClick)
end

function Lua_HeroLineupStandItem:dispose()
	self.data = nil
    self:superCall("dispose")
end

function Lua_HeroLineupStandItem:setData(data)
    self.data = data
    self.nameText.text = data.name
    if DataCenter.roleData.level >= data.unlock_lvl and DataCenter.mainLineData:getCheckpointIsCompleted(data.mainline_unlock) then
        self.bUnlock = true
    else
        self.bUnlock = false
    end
    self.icon:setGray(not self.bUnlock)
    self.icon:setAltas("hero_embattle", data.stand_icon)
end

function Lua_HeroLineupStandItem:setSelected(bSelect)
    if bSelect then
        self.bg:setAltas("hero_embattle", "xui_bz_widget_17")
    else
        self.bg:setAltas("hero_embattle", "xui_bz_widget_18")
    end
end

function Lua_HeroLineupStandItem:onIconClick()
    if self.bUnlock ~= true then
        if self.data.mainline_unlock > 0 then
            local config = Lua_MainLineCheckpointConfigData.getConfig(self.data.mainline_unlock)
            OperateAlert.show(LanUtil.formateStr(126327, config.name, self.data.unlock_lvl))
        else
            OperateAlert.show(LanUtil.formateStr(126320, self.data.unlock_lvl))
        end
    else
        Lua_MsgUtil.callFunc("LINEUP_ON_SELECT_STAND_TYPE", self.data.id)
    end
end