--英雄布阵
checkRequire("Lua_BaseLineupWindow");
checkRequire("Lua_HeroLineupTabCell");
Lua_HeroLineupWindow = class("Lua_HeroLineupWindow", Lua_BaseLineupWindow)
function Lua_HeroLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_HeroLineupWindow";
    self.skinName = "HeroLineupWindow_skin";
    self.lineupType = 0;
end

function Lua_HeroLineupWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.connEffX_1 = 35
    self.connEffY_1 = -35
    self.connEffX_2 = -270
    self.connEffY_2 = -65

    self:addLuaEvent("UPDATE_HERO_LINEUP_INFO", self, self.onLineupInfoUpdate); -- 阵容保存

    self.connIcon:addClickFuntion(self, self.checkConnect);
    self.btnSave:addClickFuntion(self, self.onBtnSaveClick);

    self.forceNum = Lua_NumberImage.new(self.bottomObject);
    self.forceNum:setLocation(0, 638, 0);
    self.forceNum.firstStr = "xui_zl1_number_10";
    self.forceNum.preStr = "xui_zl1_number_0";
    self.forceNum.numOffsetX = -2;
    self.forceNum.num = 0;
end

function Lua_HeroLineupWindow:dispose()
    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    if self.buttonList then
        self.buttonList:dispose();
        self.buttonList = nil;
    end
    self.tabInfo = nil
    self:superCall("dispose");
end

function Lua_HeroLineupWindow:updateShowInfo(param)
    if type(param) == type_str_table then
        local arr;
        if type(param[1]) == type_str_number then
            arr = Array();
            local vo;
            for i = 1, #param do
                vo = DataCenter.heroLineupData:getLineupVo(param[i]);
                arr:add(vo);
            end
        else
            arr = param;
        end
        if self.buttonList == nil then
            self.buttonList = Lua_ButtonList.new(self.bottomObject, Lua_AxisDefine.Horizontal);
            self.buttonList:setRectPivot(5);
            self.buttonList:setLocation(330, 540, 0);
            self.buttonList:setButtonCell(Lua_HeroLineupTabCell);
            self.buttonList:setButtonItem(165, 57);
            self.buttonList:setClickCallBack(self, self.onButtonClick);
        end
        self.buttonList:setData(arr);
        self.buttonList:setSelected(1);
    elseif type(param) == type_str_number then
        self.lineupType = param;
        self:showSceneByLineupType(self.lineupType);
        self:updateLineupInfo();
        self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
    end
end

function Lua_HeroLineupWindow:onButtonClick(index, data)
    if self.lineupType ~= 0 and self.lineupType ~= data.id then
        if self:checkIsChange() then
            self.switchLineupType = data.id;
            self:showTipsWindow();
            return
        end
    end
    self.lineupType = data.id;

    self:showSceneByLineupType(self.lineupType);
    self:updateLineupInfo();
    self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
end

function Lua_HeroLineupWindow:updateLineupNum()
    self.lineupNum = self.data:getHeroNumByLineupIdx(self.lineupIdx)
end

-- 更新光环
function Lua_HeroLineupWindow:updateAureoleInfo()
    local num = DataCenter.heroLineupData:calcLineupForce(self.lineupType, self.lineupIdx);
    self.forceNum.num = num;

    num = self.data:getConnectActivateNum(self.lineupIdx)
    self.connIcon:setAltas("hero_embattle", "xui_bz_widget_"..24 + num)
    self.connCount.text = num
end

function Lua_HeroLineupWindow:onLineupInfoUpdate(lineupType)
    if self.data then
        self.data:initLocalInfo();
    end
    self:updateLineupInfo();
    self:updateHeroList();
end

function Lua_HeroLineupWindow:checkConnect(go)
    local num, arr = DataCenter.heroLineupData:getConnectArrByLineup(self.lineupType, self.lineupIdx)
    if arr == nil or arr:getSize() <= 0 then
        OperateAlert.showLangValue(126066)
        return
    end
    Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, arr)
end

-- 布阵改变提示
function Lua_HeroLineupWindow:showTipsWindow()
    local tipData = { des = 126306, posY = 30, btnType = 1, onFunType = 0, owner = self, cancelFun = self.onCancelFun, sureFun = self.onSureFun };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroLineupWindow:onCancelFun()
    if self.switchLineupType then -- 切换页签
        self.lineupType = self.switchLineupType
        self.switchLineupType = nil
        self:onLineupInfoUpdate();
    else
        self:hide();
    end
end

function Lua_HeroLineupWindow:onSureFun()
    if self:checkIsNull() then
        self:onLineupInfoUpdate();
        return;
    end

    self:onSaveLineup();
    if self.switchLineupType then -- 切换页签
        self.lineupType = self.switchLineupType
        self.switchLineupType = nil
        self:onLineupInfoUpdate();
    end

    if self.needCloseWin == true then
        self:hide();
    end
end

function Lua_HeroLineupWindow:onBackBtnClick(go)
    if self:checkIsChange() == true then
        self.needCloseWin = true;
        self:showTipsWindow();
    else
        self:hide();
    end
end

function Lua_HeroLineupWindow:checkIsNull()
    if self.lineupNum == 0 and self.data.down_lineup == 0 then
        OperateAlert.showLangValue(126307);
        return true;
    end
    return false;
end

-- 保存
function Lua_HeroLineupWindow:onBtnSaveClick()
    if self:checkIsNull() then
        return;
    end

    if self.lineupNum < 2 then
        local arr = self.data:getHeroArr(self.lineupIdx);
        local heroVo;
        for i = 1, arr:getSize() do
            if arr[i] > 0 then
                heroVo = DataCenter.heroLineupData:getHeroVo(self.lineupType, arr[i]);
                if heroVo.trial_state then
                    OperateAlert.showLangValue(126330);
                    return;
                end
            end
        end
    end

    if self:checkIsChange() == false then
        return;
    end

    self:onSaveLineup();
    if self.needCloseWin == true then
        self:hide();
    end
end















-- 光环属性item
Lua_HeroAureoleAttrItem = class("Lua_HeroAureoleAttrItem", Lua_DisplayObject);
function Lua_HeroAureoleAttrItem:ctor(p)
    self:superCall("ctor", p, "HeroAureoleAttrItem_skin");
end

function Lua_HeroAureoleAttrItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroAureoleAttrItem:setData(attrVo)
    self.attr_value.text = LanUtil.formateStr(10049, tostring(attrVo.showValue));
    self.attr_value:resetSize();
    self.attr_icon:setAltas("common_altas_2", attrVo.attr_icon_1);
end

function Lua_HeroAureoleAttrItem.Get:itemW()
    return 35 + self.attr_value.width;
end

function Lua_HeroAureoleAttrItem:dispose()
    self:superCall("dispose");
end