-- 无穷战殿 个人布阵
checkRequire("Lua_FightLineupWindow");
Lua_InfinityHallIndividualWindow = class("Lua_InfinityHallIndividualWindow", Lua_FightLineupWindow);
function Lua_InfinityHallIndividualWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_InfinityHallIndividualWindow";
	self.skinName = "FightLineupWindow_skin";
end

function Lua_InfinityHallIndividualWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.stand_bg:setEnable(false)
	self.stand_btn:setEnable(false)
	self.stand_name:setEnable(false)
	self.one_btn:setEnable(false)

	self.checkHelp = UICreate.createUIAtlasImage(self.topObject, "common_altas_1", "ui_common_button_016_n", -320, -215, 0, 0);

	self.promptText = UICreate.createLabel(self.topObject, LanUtil.getValue(126322), -235, -215, 100, 31, 22);
	self.promptText.alignmentValue = 3;
	self.promptText.horizontalOverflowValue = 1;
end

function Lua_InfinityHallIndividualWindow:dispose()
	if self.teamArr ~= nil then
		self.teamArr:dispose();
		self.teamArr:clear();
		self.teamArr = nil;
	end
	self:superCall("dispose");
end

function Lua_InfinityHallIndividualWindow:updateShowInfo(param)
	self.standType = 7; -- 站位类型
	self.template_id = param.template_id;
	self.lineupType = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;
	self.monster_player_id = param.monster_player_id -- 配置表怪物

	self:showSceneByTemplateId(self.template_id);
	self:updateLineupInfo();
	self:updateEnemyInfo();
	self.campSiftPanel:setSelected(self.defaultCamp, 0);

	self.team_number = DataCenter.heroLineupData:getLineupVo(self.lineupType).team_number;
	self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:updateSceneModel()
	if self.heroDic == nil or self.lineupIdx == nil then
		return;
	end

	-- 先锋->后援1->后援2
	local tab = {}
	local uniqueId
	for i = 1, #self.heroDic do
		for j = 1, self.heroDic[i]:getSize() do
			uniqueId = self.heroDic[i][j]
			if uniqueId > 0 then
				tab[j] = DataCenter.heroData:getItemByUniqueId(uniqueId)
				break
			end
		end
		if uniqueId > 0 then
			break
		end
	end
	self:showSceneModel(tab);
end

function Lua_InfinityHallIndividualWindow:updateLineupNum()

end

function Lua_InfinityHallIndividualWindow:updateTeamInfo()
	if self.teamArr == nil then
		self.teamArr = Array();
	end

	local space = 130
	local w = -(space * self.team_number) / 2 + space / 2
	local item;
	for i = 1, self.team_number do
		item = self.teamArr[i];
		if item == nil then
			item = Lua_InfinityHallLineupTeamItem.new(self.bottomObject);
			self.teamArr:add(item);
		end
		item:setLocation(((i - 1) % self.team_number) * space + w, 800, 0);
		item:setIndex(i);
		item:setData(self.heroDic[i]);
	end	
end

function Lua_InfinityHallIndividualWindow:onHeroSelected(heroVo)
	local lineupIdx = self.data:getHeroLineupIdx(heroVo.id)
	local standIdx = self.data:getHeroStandIdx(heroVo.unique_id)
	if standIdx == nil then -- 未上阵
		teamIdx, standIdx = self:getLineupIdxAndStandIdx();
		if teamIdx == nil or standIdx == nil then -- 上阵英雄已达上限
			OperateAlert.showLangValue(126300);
			return;
		end

		if lineupIdx then
			OperateAlert.showLangValue(126302)
			return
		end

		self.data:setHeroById(teamIdx, standIdx, heroVo.unique_id)
	else
		self.data:setHeroById(lineupIdx, standIdx, 0)
	end

	self:updateHeroSelected();
	self:updateSceneModel();
	self:updateAureoleInfo();
	self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:onHeroCampPosChange(uid)
	uid = tonumber(tostring(uid));
	local heroModel = DataCenter.thingData:getThingPlayer(self.winSceneId, 0, uid);
	if heroModel == nil then
	    return;
	end

	local new_stand = heroModel.data.formationPos;
	local lineupIdx = self.data:getHeroLineupIdx(heroModel.objId)
	DataCenter.heroLineupData:updateStandChange(self.lineupType, lineupIdx, uid, new_stand, self.winSceneId, self.standType);
	self:updateHeroSelected();
	self:updateLineupNum();
	self:updateSceneModel();
	self:updateAureoleInfo();

	self:updateTeamInfo();
end

function Lua_InfinityHallIndividualWindow:onCheckLineup()
	local num = 0;
	for i = 1, #self.heroDic do
		for j = 1, self.heroDic[i]:getSize() do
			if self.heroDic[i][j] > 0 then
				num = num + 1
			end
		end
	end

	if num == 0 then
		OperateAlert.showLangValue(126307);
		return;
    elseif num == 1 then
		for i = 1, #self.heroDic do
			for j = 1, self.heroDic[i]:getSize() do
				if self.heroDic[i][j] > 0 then
					heroVo = DataCenter.heroLineupData:getHeroVo(self.lineupType, self.heroDic[i][j]);
	                if heroVo.trial_state then
	                    OperateAlert.showLangValue(126330);
	                    return true;
	                end
				end
			end
		end
	end

	if num < self.team_number and self:checkPackHaveHero() then
		local tipsData = { des = LanUtil.getValue(126319), btnType = 1, owner = self, sureFun = self.onFight };
		Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
	else
		self:onFight();
	end
end

function Lua_InfinityHallIndividualWindow:onFight()
	if self:checkLineupIsChange() then
		self:onSaveLineup();
	end
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id);
end

function Lua_InfinityHallIndividualWindow:getLineupIdxAndStandIdx()
	local lineupIdx = 0;
	local standIdx;
	while lineupIdx < self.team_number do
		lineupIdx = lineupIdx + 1;
		standIdx = DataCenter.heroLineupData:getNullStandIdx(self.standType, self.heroDic, lineupIdx);
		if standIdx ~= nil then
			return lineupIdx, standIdx;
		end
	end
	return nil, nil;
end

function Lua_InfinityHallIndividualWindow:checkPackHaveHero()
	local existDic = {} --已上阵英雄
	local uniqueId
	local heroId
	for i = 1, #self.heroDic do
		for j = 1, self.heroDic[i]:getSize() do
			uniqueId = self.heroDic[i][j]
			if uniqueId > 0 then
				heroId = DataCenter.heroData:getItemByUniqueId(uniqueId).id
				existDic[heroId] = j
			end
		end
	end

	local arr = DataCenter.heroData.heroUidArr
	local vo;
	for i = 1, arr:getSize() do
		vo = DataCenter.heroData:getItemByUniqueId(arr[i]);
		if existDic[vo.id] == nil and not vo.is_league_transaction and (not vo.trial_state or self.data.bShowTrial) then
			return true
		end
	end
	return false
end

function Lua_InfinityHallIndividualWindow:checkLineupIsChange()
	for i = 1, self.team_number do
		if self:checkIsChange(i) then
			return true
		end
	end
	return false;	
end




















function Lua_HeroLineupCell:updateSelected()
    local vo = DataCenter.heroLineupData:getLineupVo(self.curLineupType);
    self.standIdx = vo:getHeroStandIdx(self.data.unique_id)
    self.itemIcon:setDrawMask(self.standIdx ~= nil)
end





















Lua_InfinityHallLineupTeamItem = class("Lua_InfinityHallLineupTeamItem", Lua_DisplayObject);
function Lua_InfinityHallLineupTeamItem:ctor(p)
	self:superCall("ctor", p);
	self.teamIdx = 1;
end

function Lua_InfinityHallLineupTeamItem:buildShowItem()
	self:superCall("buildShowItem");

	self.nameText = UICreate.createLabel(self.content, nil, 0, 80, 100, 31, 22);
	self.nameText.pivot = Lua_WindowUtil.getPivot(4);
	self.nameText.alignmentValue = 4;
	self.nameText.horizontalOverflowValue = 1;

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
end

function Lua_InfinityHallLineupTeamItem:dispose()
	self.nameText = nil;
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	self:superCall("dispose");
end

function Lua_InfinityHallLineupTeamItem:setIndex(index)
	self.teamIdx = index;
	if index == 1 then
		self.nameText:setLangValue(304023);
	else
		self.nameText:setLangValue(304024);
	end
end

function Lua_InfinityHallLineupTeamItem:setData(standArr)
	local uniqueId = standArr[6]
	if uniqueId <= 0 then
		self.itemIcon:setData(nil);
	else
		self.itemIcon:setData(DataCenter.heroData:getItemByUniqueId(uniqueId));
	end
end