-- 无穷战殿 团队布阵
checkRequire("Lua_FightLineupWindow");
Lua_InfinityHallTeamWindow = class("Lua_InfinityHallTeamWindow", Lua_FightLineupWindow);
function Lua_InfinityHallTeamWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_InfinityHallTeamWindow";
end

function Lua_InfinityHallTeamWindow:buildShowItem()
	self:superCall("buildShowItem");

    self.heroList:setListCell(Lua_InfinityHallTeamHeroItem, 107, 107, 5);
    self.one_btn:setEnable(false);
end

function Lua_InfinityHallTeamWindow:dispose()
	self:superCall("dispose");
end

function Lua_InfinityHallTeamWindow:updateShowInfo(param)
	self.template_id = param.template_id;
	self.lineupType = Lua_FightTemplateConfigData.getConfigData(self.template_id).lineup_type;
	self.monster_player_id = param.monster_player_id
	
	self:showSceneByTemplateId(self.template_id);
	self:updateLineupInfo();
	self:updateEnemyInfo();
	self.campSiftPanel:setSelected(self.defaultCamp, 0);
end

function Lua_InfinityHallTeamWindow:updateSceneModel()
	if self.heroDic == nil or self.lineupIdx == nil then
		return;
	end

	local tab = {};
	local chooseHeroVo = DataCenter.infinityHallData.chooseHeroVo
	local heroVo;
	local arr = self.heroDic[self.lineupIdx];
	for i = 1, arr:getSize() do
		if arr[i] > 0 then
			if chooseHeroVo and chooseHeroVo.unique_id == arr[i] then
				tab[i] = chooseHeroVo;
			else
				heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
				tab[i] = heroVo;
			end
		end
	end

	self:showSceneModel(tab);
end

function Lua_InfinityHallTeamWindow:updateHeroList()
	local arr = DataCenter.infinityHallData:getHeroList(self.selectedCampType, self.selectedCareer, self.lineupType, self.lineupIdx);
	self.heroList.customParam = self.lineupType * 10000 + self.lineupIdx * 100
	self.heroList:setArrayData(arr);
	self.heroList:moveToIndex(1, true);
	self:showNone(arr == nil or arr:getSize() <= 0);
end

function Lua_InfinityHallTeamWindow:checkLineupIsFull(lineupIdx)
    local num = self.data:getHeroNumByLineupIdx(lineupIdx);
    if num < self.positionNum and DataCenter.infinityHallData:checkPackHaveHero(self.lineupType) then
        local tipsData = { des = 126312, btnType = 1, cancelLabel = 126328, owner = self, sureFun = self.onFight };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return true;
    end
    return false;
end




















Lua_InfinityHallTeamHeroItem = class("Lua_InfinityHallTeamHeroItem", Lua_HeroLineupCell);
function Lua_InfinityHallTeamHeroItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_InfinityHallTeamHeroItem:dispose()
	self:superCall("dispose");
end

function Lua_InfinityHallTeamHeroItem:setData(data)
	self.data = data;
	
	self.itemIcon:setData(data);
	self:showAssistHeroIcon(data.assist == 1);
	self:updateSelected();
end

function Lua_InfinityHallTeamHeroItem:showAssistHeroIcon(isShow)
	if isShow then
		if self.assistHeroIcon == nil then
			self.assistHeroIcon = UICreate.createUIAtlasImage(self.content, "common_altas_3", "ui_bjyz_label_04", 36, -33, 0, 0);
		end
		self.assistHeroIcon:setEnable(true);
	else
		if self.assistHeroIcon ~= nil then
			self.assistHeroIcon:setEnable(false);
		end
	end
end