-- 昆墟圣地
checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_FightStarPanel")
Lua_KunXuHolyLandLineupWindow = class("Lua_KunXuHolyLandLineupWindow", Lua_FightLineupWindow);
function Lua_KunXuHolyLandLineupWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_KunXuHolyLandLineupWindow";
	self.lineupType = 31;
    self.artifactPosY = 675;
end

function Lua_KunXuHolyLandLineupWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.stand_bg:setLocation(301, 62, 0)
    self.stand_btn:setLocation(301, 62, 0)
    self.stand_name:setLocation(302.5, 21, 0)

    self.heroList:setListCell(Lua_KunXuHolyLandTeamHeroItem, 107, 107, 5);
    self.one_btn:setEnable(false);
    self:createTabList();

    self.starPanel = Lua_FightStarPanel.new(self.topObject)
    self.starPanel:setRectAnchor(1)
    self.starPanel:setLocation(-325, -240.5, 0)
    self.starPanel:setShowHide(true);

    Lua_WindowUtil.openWin("Lua_KunXuHolyLandEmbattleWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭昆墟圣地战斗阵容准备界面
end

function Lua_KunXuHolyLandLineupWindow:dispose()
    if self.starPanel then
        self.starPanel:dispose()
        self.starPanel = nil
    end
	self:superCall("dispose");
    Lua_MsgUtil.callFunc("UPDATE_KUNXU_HEROLIST");
    Lua_MsgUtil.callFunc("UPDATE_KUNXUFQ_LINEUPTEAM");
end

function Lua_KunXuHolyLandLineupWindow:updateShowInfo(param)
    self.template_id = param.template_id;
    self.stage_id = param.stage_id;
    self.monster_player_id = param.monster_player_id;
    self.lineupIdx = param.teamIndex;
	self:updateLineupInfo();
    self:showSceneByTemplateId(self.template_id);
	self.tabBtnList:setSelected(param.teamIndex);
end

-- 1:左路 2：右路
function Lua_KunXuHolyLandLineupWindow:onTabBtnClick(index)
    self.lineupIdx = index;
	
    self.data:checkHeroConnect(self.lineupIdx, false, true);
    self:updateStandInfo();
    self:updateScenePosEff();
    self:updateSceneModel();
    self:updateArtifact();
    self:updateLineupNum();

    self:createHeroConnectIcon();
    self:updateAureoleInfo();
	
    if self.monster_player_id ~= nil then
        self:updateEnemyInfo();
    end
    if self.enemyLineupPanel ~= nil then
        self.enemyLineupPanel:setEnable(self.monster_player_id ~= nil);
    end
    if self.rightAureoleItem ~= nil then
        self.rightAureoleItem:setEnable(self.monster_player_id ~= nil);
    end  
    if self.up_bg ~= nil then
        self.up_bg:setEnable(self.monster_player_id ~= nil);
    end
    if self.up_bg ~= nil then
        self.up_bg:setEnable(self.monster_player_id ~= nil);
    end
    if self.defenderConnectItem ~= nil then
        self.defenderConnectItem:setEnable(self.monster_player_id ~= nil);
    end
    if self.attackerConnectItem ~= nil then
        self.attackerConnectItem:setEnable(self.monster_player_id ~= nil);
    end

    self.starPanel:setEnable(self.stage_id ~= nil);
    self.btnFight.label = self.stage_id ~= nil and LanUtil.getValue(440024) or LanUtil.getValue(440025);

    self.campSiftPanel:setSelected(self.defaultCamp, 0, true);
    self:updateStarCond();
end

function Lua_KunXuHolyLandLineupWindow:createHeroConnectIcon()
    if self.monster_player_id == nil then
        if self.connBg == nil then
            self.connBg = UICreate.createUIAtlasImage(self.topObject, "hero_embattle", "xui_bz_widget_31", -269.5, -62.5, 171, 62);
            self.connIcon = UICreate.createUIAtlasImage(self.topObject, "hero_embattle", "xui_bz_widget_24", -269.5, -62.5, 91, 91);
            self.connCount = UICreate.createLabel(self.topObject, "1", -269.5, -62.5, 100, 31, 28);
            self.connCount.pivotValue = 4;
            self.connCount.fontName = Lua_MyUISettings.fangzhengFontName;
            self.connCount.alignmentValue = 4;
            self.connCount.horizontalOverflowValue = 1;
            self.connIcon:addClickFuntion(self, self.checkConnect);
        end
    end
end

function Lua_KunXuHolyLandLineupWindow:updateAureoleInfo()
    self:superCall("updateAureoleInfo");

    if self.connIcon ~= nil then
        local num = self.data:getConnectActivateNum(self.lineupIdx)
        self.connIcon:setAltas("hero_embattle", "xui_bz_widget_"..24 + num)
        self.connCount.text = num;
    end
end

function Lua_KunXuHolyLandLineupWindow:checkConnect(go)
    local num, arr = DataCenter.heroLineupData:getConnectArrByLineup(self.lineupType, self.lineupIdx)
    if arr == nil or arr:getSize() <= 0 then
        OperateAlert.showLangValue(126066)
        return
    end
    Lua_WindowUtil.openWin("Lua_HeroConnectListWindow", Lua_WinParam.ACTION_OPEN, arr)
end

function Lua_KunXuHolyLandLineupWindow:createTabList()
	self.tabInfo = Array();
    self.tabInfo:add({ textStr = LanUtil.getValue(440026) });
    self.tabInfo:add({ textStr = LanUtil.getValue(440027) });

    self.tabBtnList = Lua_ButtonList.new(self.bottomObject, Lua_AxisDefine.Horizontal);
    self.tabBtnList:setRectPivot(5)
    self.tabBtnList:setLocation(359, 541, 0)
    self.tabBtnList:setButtonStyle("common_altas_3", "xui_common_toggle_003_b", "xui_common_toggle_003_f", 174, 57, 1, 1);
    self.tabBtnList:setButtonText(0, -5, "B2B0A6", "894E23", 28, 30, Lua_MyUISettings.huakangFontName, fontStyle)
    self.tabBtnList:setButtonItem(168, 54);
    self.tabBtnList:setClickCallBack(self, self.onTabBtnClick);
    self.tabBtnList:setData(self.tabInfo);
end

--选择英雄
function Lua_KunXuHolyLandLineupWindow:onHeroSelected(heroVo)
    self:superCall("onHeroSelected", heroVo);
    self:updateStarCond();
end

function Lua_KunXuHolyLandLineupWindow:onHeroCampPosChange(uid)
    self:superCall("onHeroCampPosChange", uid);
    self:updateStarCond();
end

function Lua_KunXuHolyLandLineupWindow:updateStarCond()
    if self.stage_id == nil then
        self.starPanel:setEnable(false);
    else
        local campCareerDic, campDic, careerDic, num = self:calcData();
        local levelInfo = DataCenter.kunXuHolyLandData:getLevelInfoById(self.stage_id); 
        local arr = levelInfo.starCondArr;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:init();
            arr[i]:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
            arr[i]:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
        end
        self.starPanel:setData(nil, arr);
        self.starPanel:setEnable(true);
    end
end

function Lua_KunXuHolyLandLineupWindow:calcData()
    local vo;
    local campCareerDic = {};
    local campDic = {};
    local careerDic = {};
    local uniqueId;
    local num = 0;
    for i = 1, #self.heroDic do
        for j = 1, self.heroDic[i]:getSize() do
            uniqueId = self.heroDic[i][j]
            if uniqueId > 0 then
                vo = DataCenter.heroData:getItemByUniqueId(uniqueId);

                if campCareerDic[vo.campType] == nil then
                    campCareerDic[vo.campType] = {};
                end
                if campCareerDic[vo.campType][vo.career] == nil then
                    campCareerDic[vo.campType][vo.career] = 1;
                else
                    campCareerDic[vo.campType][vo.career] = campCareerDic[vo.campType][vo.career] + 1;
                end
                if campDic[vo.campType] == nil then
                    campDic[vo.campType] = 1;
                else
                    campDic[vo.campType] = campDic[vo.campType] + 1;
                end
                if careerDic[vo.career] == nil then
                    careerDic[vo.career] = 1;
                else
                    careerDic[vo.career] = careerDic[vo.career] + 1;
                end
                num = num + 1;
            end
        end
    end

    return campCareerDic, campDic, careerDic, num;
end

function Lua_KunXuHolyLandLineupWindow:onCheckLineup()
    local num
    for i = 1, self.data.team_number do
        num = self.data:getHeroNumByLineupIdx(i)
        if num == 0 then
            OperateAlert.show(LanUtil.formateStr(126326, convert_arab_to_chinese(i)));
            return
        elseif num == 1 then
            local arr = self.data:getHeroArr(i);
            local heroVo;
            for j = 1, arr:getSize() do
                if arr[j] > 0 then
                    heroVo = DataCenter.heroLineupData:getHeroVo(self.lineupType, arr[j]);
                    if heroVo.trial_state then
                        OperateAlert.showLangValue(126330);
                        return;
                    end
                end
            end
        end
    end

    if self.monster_player_id ~= nil then
        for i = 1, self.data.team_number do
            num = self.data:getHeroNumByLineupIdx(i)
            if num < self.positionNum and DataCenter.heroLineupData:checkPackHaveHero(self.lineupType) then
                local tipsData = { des = 126312, btnType = 1, cancelLabel = 126328, owner = self, sureFun = self.onFight }
                Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
                return
            end
        end
    end
    self:onFight();
end

function Lua_KunXuHolyLandLineupWindow:onFight()
    if self:checkIsChange() then
        self:onSaveLineup()
    end
    if self.monster_player_id ~= nil then
        Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
    end
end



















Lua_KunXuHolyLandTeamHeroItem = class("Lua_KunXuHolyLandTeamHeroItem", Lua_HeroLineupCell);
function Lua_KunXuHolyLandTeamHeroItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_KunXuHolyLandTeamHeroItem:updateSelected()
    local vo = DataCenter.heroLineupData:getLineupVo(self.curLineupType);
    self.lineupIdx = vo:getHeroLineupIdx(self.data.id)
    self.standIdx = vo:getHeroStandIdx(self.data.unique_id)
    
    self.itemIcon:showText(0, nil)
    if self.lineupIdx == self.curLineupIdx then
        self.itemIcon:setDrawMask(self.standIdx ~= nil)
        self.itemIcon:setMask(false)
        self:showKunXuDisplay(false);
    else
        self.itemIcon:setDrawMask(false)
        if self.lineupIdx then
            self.itemIcon:setMask(true)
            if self.standIdx == nil then
                self:showKunXuDisplay(false);
            else
                local str = self.lineupIdx == 1 and LanUtil.getValue(440026) or LanUtil.getValue(440027);
                self:showKunXuDisplay(true, str);
            end
        else
            self.itemIcon:setMask(false);
            self:showKunXuDisplay(false);
        end
    end
end

function Lua_KunXuHolyLandTeamHeroItem:showKunXuDisplay(bool, showStr)
    if bool then
        if self.kunXuTxt == nil then
            self.kunXuTxt = UICreate.createLabel(self.content, nil, 3, -24, 100, 36, 20);
            self.kunXuTxt.colorStr = Lua_ColorDefine.transColorStr("ffefb3");
            self.kunXuTxt.horizontalOverflowValue = 1;
            self.kunXuTxt.alignmentValue = 4;
            self.kunXuTxt.effectStyle = 2;
            self.kunXuTxt.effectColorStr = Lua_ColorDefine.transColorStr("7F3B0E");
            self.kunXuTxt:setEffectDistance(2, 2);
        end     
        self.kunXuTxt.text = showStr;

        if self.kunXuSp == nil then
            self.kunXuSp = UICreate.createUIAtlasImage(self.content, "kunxuholyland_altas", "xui_kxsd_label_3", 0, 12, 30, 36);
        end
        self.kunXuSp:setEnable(true);
    else
        if self.kunXuTxt ~= nil then
            self.kunXuTxt.text = "";
        end
        if self.kunXuSp ~= nil then
            self.kunXuSp:setEnable(false);
        end
    end
end

function Lua_KunXuHolyLandTeamHeroItem:kunXuDispose()
    if self.kunXuTxt ~= nil then
        self.kunXuTxt:dispose();
        self.kunXuTxt = nil;
    end
    if self.kunXuSp ~= nil then
        self.kunXuSp:dispose();
        self.kunXuSp = nil;
    end
end