-- 剧情关卡
checkRequire("Lua_FightLineupWindow");
Lua_NewHeroActStoryLineupWindow = class("Lua_NewHeroActStoryLineupWindow", Lua_FightLineupWindow);
function Lua_NewHeroActStoryLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_NewHeroActStoryLineupWindow";
end

function Lua_NewHeroActStoryLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.heroList:setListCell(Lua_NewHeroActStoryLineupItem, 107, 107, 5);
end

function Lua_NewHeroActStoryLineupWindow:dispose()
    self:superCall("dispose");
end

function Lua_NewHeroActStoryLineupWindow:updateShowInfo(param)
    -- if DataCenter.newHeroActData.storyLevelHeroLineup ~= nil then
    --     local info = { lineup_type = Lua_HeroUtil.LINEUP_STORY, detachment_list = DataCenter.newHeroActData.storyLevelHeroLineup };
    --     DataCenter.heroLineupData:addLineupInfo(info);
    -- end

    -- self:superCall("updateShowInfo", param);

    self.template_id = param.template_id;
    self.stage_id = param.stage_id;
    self.monster_player_id = param.monster_player_id;

    if DataCenter.newHeroActData.storyLevelHeroLineup ~= nil then
        local info = { lineup_type = Lua_HeroUtil.LINEUP_STORY, detachment_list = DataCenter.newHeroActData.storyLevelHeroLineup };
        DataCenter.heroLineupData:addLineupInfo(info);
    end

    self.lineupType = Lua_HeroUtil.LINEUP_STORY;
    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self:updateEnemyInfo();
    self.campSiftPanel:setSelected(self.defaultCamp, 0);
end

function Lua_NewHeroActStoryLineupWindow:updateHeroList()
    local arr = DataCenter.newHeroActData:getStoryLevelLineupHeroList(self.selectedCampType, self.selectedCareer, self.lineupType, self.lineupIdx);--self:getHeroList(self.selectedCampType, self.selectedCareer);--DataCenter.newHeroActData.getStoryLevelLineupHeroList;
    self.heroList.customParam = self.lineupType * 10000 + self.lineupIdx * 100
    self.heroList:setArrayData(arr); -- 剧情布阵可选英雄列表
    self:showNone(arr == nil or arr:getSize() <= 0);
end

-- 更新模型展示
function Lua_NewHeroActStoryLineupWindow:updateSceneModel()
    if self.heroDic == nil or self.lineupIdx == nil then
        return;
    end

    local tab = {};
    local arr = self.heroDic[self.lineupIdx];
    local heroVo;
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            heroVo = DataCenter.newHeroActData:getStoryLevelHeroVoByUId(arr[i]);
            tab[i] = heroVo;
        end
    end

    self:showSceneModel(tab);
end

-- 站位
function Lua_NewHeroActStoryLineupWindow:getAureoleInfo(arr)
    local tab = {};
    local heroVo;
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            heroVo = DataCenter.newHeroActData:getStoryLevelHeroVoByUId(arr[i]);
            if tab[heroVo.campType] == nil then
                tab[heroVo.campType] = 1;
            else
                tab[heroVo.campType] = tab[heroVo.campType] + 1;
            end
        end
    end
    return tab;
end

function Lua_NewHeroActStoryLineupWindow:checkLineupIsFull(lineupIdx)
    local num = self.data:getHeroNumByLineupIdx(lineupIdx)
    if num < self.positionNum and DataCenter.newHeroActData:checkPackHaveHero(self.heroDic) then
        local tipsData = { des = 126312, btnType = 1, cancelLabel = 126328, owner = self, sureFun = self.onFight };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        return true;
    end
    return false;
end

function Lua_NewHeroActStoryLineupWindow:onFight()
    if self:checkIsChange() then
        -- 设置新的阵容
        -- Lua_MsgUtil.callFunc("SET_NEWHEROSTORY_LINEUP_INFO", {stage_id = self.stage_id, standType = self.data.standTypeDic, hero_lineup = self.heroDic, artifact_list = self.artifactDic});
        local actIdx = DataCenter.newHeroActData.storyLevelActId;
        Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sStoryLineup(actIdx, self.stage_id, self.data.standTypeDic, self.heroDic, self.artifactDic);
    end
    DataCenter.newHeroActData.storyCurFightLevelId = self.stage_id;
    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
end

-- 策划要求：不用神器
function Lua_NewHeroActStoryLineupWindow:onCheckArtifact()
    self:onCheckLineup();
end

function Lua_NewHeroActStoryLineupWindow:updateArtifact()
    self:updateAureoleInfo();
    self.artifact_bg:setEnable(false);
end


--------------------------------------------------





Lua_NewHeroActStoryLineupItem = class("Lua_NewHeroActStoryLineupItem", Lua_HeroLineupCell);
function Lua_NewHeroActStoryLineupItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_NewHeroActStoryLineupItem:setData(data)
    self.data = data;
    if data == nil then
        return;
    end
    
    self.itemIcon:setData(data);
    self:updateSelected();
end

function Lua_NewHeroActStoryLineupItem:onPressClick()
    if DataCenter.newHeroActData:checkCharacterHero(self.data.unique_id)then
        OperateAlert.showLangValue(763014);
        return false;
    else
        Lua_MsgUtil.callFunc("LINEUP_HERO_SELECT", self.data);
        return true;
    end
end

function Lua_NewHeroActStoryLineupItem:onLongPressClick()
    if not Lua_WindowUtil.isWindowShowing("Lua_HeroTipsWindow") then
        Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sMonsterId(self.data.unique_id);
    end
end

function Lua_NewHeroActStoryLineupItem:dispose()
    self:superCall("dispose");
end