-- 巅峰对决
checkRequire("Lua_HeroLineupWindow")
Lua_PeakDuelLineupWindow = class("Lua_PeakDuelLineupWindow", Lua_HeroLineupWindow)
function Lua_PeakDuelLineupWindow:ctor()
    self:superCall("ctor")
    self.windowName = "Lua_PeakDuelLineupWindow"
end

function Lua_PeakDuelLineupWindow:buildShowItem()
    self:superCall("buildShowItem")
    local data = Lua_WindowUtil.getWinListData(self.windowName)
    if data == nil then
        self:updateShowInfo()
    end
end

function Lua_PeakDuelLineupWindow:dispose()
    self:superCall("dispose")
end

function Lua_PeakDuelLineupWindow:updateShowInfo(param)
    local config = DataCenter.peakDuelUtil:getSegmentInfoByid(DataCenter.peakDuelData.segmentLvl)
    self.bSatisfySegment = config.team_num > 1
    
    self.lineupIdx = param or 1
    self.lineupType = Lua_HeroUtil.LINEUP_PEAKDUEL
    self:showSceneByLineupType(self.lineupType)

    self:updateLineupInfo()
    
    self:createTeamButton(self.data.team_number)
    self:onTeamSelected(self.lineupIdx, true)
end

function Lua_PeakDuelLineupWindow:onTeamSelected(lineupIdx, bUpdate)
    if lineupIdx > 1 and not self.bSatisfySegment then
        OperateAlert.showLangValue(202950)
        return
    end
    self:superCall("onTeamSelected", lineupIdx, bUpdate)
end

function Lua_PeakDuelLineupWindow:checkIsChange(lineupIdx)
    if not self.bSatisfySegment then
        lineupIdx = lineupIdx or self.lineupIdx
        return self.data:checkLineupIsChange(lineupIdx)
    else -- 开启了多队
        for i = 1, self.data.team_number do
            if self.data:checkLineupIsChange(i) then
                return true
            end
        end
    end
    return false
end

function Lua_PeakDuelLineupWindow:checkIsNull()
    if not self.bSatisfySegment then
        if self.lineupNum == 0 and self.data.down_lineup == 0 then
            OperateAlert.showLangValue(126307);
            return true;
        end
    else
        for i = 1, self.data.team_number do
            num = self.data:getHeroNumByLineupIdx(i)
            if num == 0 then
                OperateAlert.show(LanUtil.formateStr(126326, convert_arab_to_chinese(i)));
                return true;
            end
        end
    end
    return false;
end