-- 星魂试炼 战斗布阵Window
checkRequire("Lua_FightLineupWindow");
checkRequire("Lua_FightStarPanel")
Lua_StarTrialLineupWindow = class("Lua_StarTrialLineupWindow", Lua_FightLineupWindow);
function Lua_StarTrialLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_StarTrialLineupWindow";
end

function Lua_StarTrialLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value")
    value = value == nil and 0 or value
    local curChapter = DataCenter.starTrialData.curChapter
    if curChapter - 1 < value then
        self.stand_bg:setLocation(302, 54.5, 0)
        self.stand_btn:setLocation(302, 54.5, 0)
        self.stand_name:setLocation(302, 17.5, 0)
        self.one_btn:setEnable(false)
    else
        self.stand_bg:setLocation(302, 570, 0)
        self.stand_btn:setLocation(302, 570, 0)
        self.stand_name:setLocation(302, 533, 0)
        self.one_btn:setEnable(true)
    end

    self.starPanel = Lua_FightStarPanel.new(self.topObject)
    self.starPanel:setRectAnchor(1)
    self.starPanel:setLocation(-325, -240.5, 0)
    self.starPanel:setShowHide(true)
end

function Lua_StarTrialLineupWindow:dispose()
    if self.starPanel then
        self.starPanel:dispose()
        self.starPanel = nil
    end
    self:superCall("dispose")
end

function Lua_StarTrialLineupWindow:updateShowInfo(param)
    self:superCall("updateShowInfo", param);
    self:updateStarCond();
end

--选择英雄
function Lua_StarTrialLineupWindow:onHeroSelected(heroVo)
    self:superCall("onHeroSelected", heroVo);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:onHeroCampPosChange(uid)
    self:superCall("onHeroCampPosChange", uid);
    self:updateStarCond();
end

function Lua_StarTrialLineupWindow:updateStarCond()
    local campCareerDic, campDic, careerDic, num = self:calcData();
    local stageVo = DataCenter.starTrialUitl:getStageVo(self.showData.stage_id);
    local arr = stageVo.starCondArr;
    local len = arr:getSize();
    for i = 1, len do
        arr[i]:init();
        arr[i]:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
        arr[i]:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
    end
    self.starPanel:setData(nil, arr)
end

function Lua_StarTrialLineupWindow:calcData()
    local vo;
    local campCareerDic = {};
    local campDic = {};
    local careerDic = {};
    local num = 0;
    local arr = self.heroDic[self.lineupIdx]
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            vo = DataCenter.heroData:getItemByUniqueId(arr[i]);

            if campCareerDic[vo.campType] == nil then
                campCareerDic[vo.campType] = {};
            end
            if campCareerDic[vo.campType][vo.career] == nil then
                campCareerDic[vo.campType][vo.career] = 1;
            else
                campCareerDic[vo.campType][vo.career] = campCareerDic[vo.campType][vo.career] + 1;
            end
            if campDic[vo.campType] == nil then
                campDic[vo.campType] = 1;
            else
                campDic[vo.campType] = campDic[vo.campType] + 1;
            end
            if careerDic[vo.career] == nil then
                careerDic[vo.career] = 1;
            else
                careerDic[vo.career] = careerDic[vo.career] + 1;
            end
            num = num + 1;
        end
    end

    -- for campType, tab in pairs(campCareerDic) do
    --     for career, n in pairs(tab) do
    --         print(campType, career, n)
    --     end
    -- end
    return campCareerDic, campDic, careerDic, num;
end

-- 一键上阵
function Lua_StarTrialLineupWindow:onOneBtnClick(go)
    -- local value = DataCenter.starTrialUitl:getConstConfig("line_up_one_key", "value");
    -- value = value == nil and 0 or value;
    -- local curChapter = DataCenter.starTrialData.curChapter;
    -- if curChapter - 1 < value then
    --     OperateAlert.show(LanUtil.formateStr(201628, tostring(value)));
    --     return;
    -- end

    local arr = DataCenter.heroLineupData:getHeroList(0, 0, self.lineupType, self.lineupIdx, 1);
    local len = arr:getSize();
    if len <= 0 then
        return;
    end

    local list = DataCenter.heroLineupUtil:getStandListByType(self.standType);
    local need_num = #list;
    local standArr = self.heroDic[self.lineupIdx]
    for i = 1, standArr:getSize() do -- 一键上阵，需要卸下当前所有英雄再重新上阵
        standArr[i] = 0
    end
    
    local stageVo = DataCenter.starTrialUitl:getStageVo(self.showData.stage_id);
    local starVo = stageVo.starCondArr[2];
    local campCareerDic, campDic, careerDic, num = self:calcData();
    starVo:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
    starVo:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);

    local existCamp = {};
    local existCareer = {};
    function setCampCareer(condVo)
        if condVo and condVo.bMeet and (condVo.condType == 4 or condVo.condType == 5 or condVo.condType == 7) then
            if condVo.value1 == 0 then
                if condVo.value2 > 0 then
                    existCareer[condVo.value2] = 1;
                end
            else
                existCamp[condVo.value1] = 1;
                if condVo.value2 > 0 then
                    existCareer[condVo.value2] = 1;
                end
            end
        end
    end

    local condArr = starVo.condArr
    for i = 1, condArr:getSize() do
        setCampCareer(condArr[i])
    end

    local existDic = {};
    local heroArr = Array();
    function setHeroLineup(standIdx, heroVo, condVo)
        standArr[standIdx] = heroVo.unique_id;
        existDic[heroVo.id] = standIdx;
        need_num = need_num - 1;
        campCareerDic, campDic, careerDic, num = self:calcData();
        starVo:checkCampAndCareerMax(campCareerDic, campDic, careerDic, num);
        starVo:checkCampAndCareerMin(campCareerDic, campDic, careerDic, num);
        setCampCareer(condVo)
        heroArr:add(heroVo.unique_id)
    end

    local standIdx;
    local heroVo;
    local condVo;
    for i = 1, #list do
        standIdx = list[i];
        if standArr[standIdx] == 0 then
            condVo = starVo:getUnMeetVo();
            if condVo == nil then
                for j = 1, len do
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
                    if existDic[heroVo.id] == nil and existCamp[heroVo.campType] == nil and existCareer[heroVo.career] == nil then
                        setHeroLineup(standIdx, heroVo);
                        break;
                    end
                end
            else
                for j = 1, len do
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
                    if existDic[heroVo.id] == nil then
                        if condVo.value1 == 0 then
                            if condVo.value2 == 0 then
                                setHeroLineup(standIdx, heroVo, condVo);
                                break;
                            else
                                if heroVo.career == condVo.value2 then
                                    setHeroLineup(standIdx, heroVo, condVo);
                                    break;
                                end
                            end
                        else
                            if condVo.value2 == 0 then
                                if heroVo.campType == condVo.value1 then
                                    setHeroLineup(standIdx, heroVo, condVo);
                                    break;
                                end
                            else
                                if heroVo.campType == condVo.value1 and heroVo.career == condVo.value2 then
                                    setHeroLineup(standIdx, heroVo, condVo);
                                    break;
                                end
                            end
                        end
                    end
                end
            end
        end
    end

    -- if need_num > 0 and not starVo.isMeet then
    if need_num > 0 then
        for i = 1, #list do
            standIdx = list[i];
            if standArr[standIdx] == 0 then
                for j = 1, len do
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
                    if existDic[heroVo.id] == nil then
                        setHeroLineup(standIdx, heroVo);
                        break;
                    end
                end
            end
            if need_num == 0 then
                break;
            end
        end
    end

    if not starVo.isMeet then -- 策划需求：不满足则无视条件，所以上面的计算都是浪费的
        for i = 1, standArr:getSize() do
            standArr[i] = 0
        end

        table.clear(existDic)

        for i = 1, #list do
            standIdx = list[i];
            if standArr[standIdx] == 0 then
                for j = 1, len do
                    heroVo = DataCenter.heroData:getItemByUniqueId(arr[j]);
                    if existDic[heroVo.id] == nil then
                        setHeroLineup(standIdx, heroVo);
                        break;
                    end
                end
            end
            if need_num == 0 then
                break;
            end
        end
    end

    -- 按战斗系统站位上阵
    DataCenter.heroLineupData:heroListSortByForce(heroArr);
    DataCenter.heroLineupData:setHeroOneKey(self.standType, self.heroDic, self.lineupIdx, self.lineupType, heroArr);

    self.data:initLineUpInfo();
    self:updateHeroSelected();
    self:updateSceneModel();
    self:updateLineupNum();
    self:updateAureoleInfo();
    self:updateStarCond();
end